package org.gvsig.fmap.dal.store.csv.simplereaders;

import java.io.IOException;
import java.util.List;

public interface SimpleReader {

    public String[] getHeader() throws IOException;

    public List<String> read() throws IOException;

    public void close() throws IOException;

    public List<String> skip(int lines) throws IOException;
    
    public int getLine();
}
