PATH="$PWD/tools;$PATH"
ROOT="$PWD"
echo -e "\nCurrent directory: $ROOT"
echo -e "\nDump file list and sizes\n"
du -k "$ROOT"
echo -e "\nCalculating md5sum of dlls and exes...\n"
cd "$ROOT"
for f in $(find . -name "*.exe")
do
	md5sum $f
done
for f in $(find . -name "*.dll")
do
	md5sum $f
done
echo -e "\nCheck DLL dependencies...\n"
for f in $(find . -name "*.dll")
do
	cygcheck.exe "$f"
	echo ""
done
